import type { ReadonlyVec } from "@thi.ng/vectors";
import type { SubdivKernel } from "./api.js";
/**
 * Takes an array of `points` and an array of subdivision `kernels`. Iterativel
 * applies kernels in given order (each iteration operating on the result of the
 * previous iteration). The `closed` flag (default: false) indicates if the
 * points define a closed or open geometry (i.e. polygon vs. polyline).
 *
 * @remarks
 * References:
 *
 * - https://web.archive.org/web/20060816003547/https://algorithmicbotany.org/papers/subgpu.sig2003.pdf
 * - https://www.csl.mtu.edu/cs3621/common/Subdivision.pdf
 *
 * @param points - source points
 * @param kernels - subdivision scheme(s)
 * @param closed
 */
export declare function subdivide(points: ReadonlyVec[], kernels: SubdivKernel[], closed?: boolean): ReadonlyVec[];
//# sourceMappingURL=subdivide.d.ts.map